#include "dbstruct.ch"
#include "minigui.ch"

static aGrid := { }, aCustSource := { }, aCustDisp := { }, ;
       aItemSource := { }, aItemDisp := { }, aItemRate := { }, ;
       lChanged := .f., lAddMode := .f.

Function Main
   local i, cb

   SetProg()
   CreateTable()
   select sale
   set order to tag invno
   go top
   CreateLookup()

   DEFINE WINDOW Form_1 ;
          AT 0, 0 ;
          WIDTH 750 ;
          HEIGHT 460 ;
          TITLE "One To Many Form (Ver 1.1)" ;
          MAIN ;
          on init RefreshWin()

   @ 10, 10 label lblInvno value "Invoice No.:"
   @ 10, 100 textbox txtInvno ;
      readonly

   @ 10, 230 label lblInvdt value "Date:"
   @ 10, 280 datepicker dpkInvdt ;
      on change ValChanged()

   @ 40, 10 label lblCustcd value "Customer:"
   @ 40, 100 COMBOBOX cboCustcd ;
      items aCustDisp ;
      width 200 ;
      on change ValChanged()

   @ 70, 10 GRID grdSaledtl ;
      WIDTH 400 ;
      HEIGHT 250 ;
      HEADERS { 'Item', 'Rate', 'Qty', 'Amt' } ;
      WIDTHS { 150, 75, 75, 75 } ;
      COLUMNCONTROLS { { 'COMBOBOX', aItemDisp }, ;
                       { 'TEXTBOX', 'NUMERIC', '999999.99' }, ;
                       { 'TEXTBOX', 'NUMERIC', '999999' }, ;
                       { 'TEXTBOX', 'NUMERIC', '99999999.99' } } ;
      edit ;
      justify { 0, 1, 1, 1 } ;
      on lostfocus calcamt() ;
      on change ValChanged() ;
      COLUMNWHEN { { || .t. }, { || .f. }, { || .t. }, { || .f. } }

   @ 320, 10 label lblMesg1 value "(Ins: Add New, Del: Delete)" width 200
   
   @ 330, 230 label lblTotamt value "Total:"
   @ 330, 270 textbox txtTotamt ;
      readonly ;
      numeric ;
      inputmask "9999999.99"

   @ 10, 430 BROWSE Browse_1            ;
      WIDTH 300              ;
      HEIGHT 410             ;
      HEADERS { 'Inv No' , 'Inv Dt', 'Tot Amt' }   ;
      WIDTHS { 75, 100, 100 }         ;
      WORKAREA Sale         ;
      FIELDS { 'Sale->invno' , 'Sale->invdt', 'Sale->totamt' } ;
      justify { 0, 2, 1 } ;
      ON CHANGE RefreshWin()
   
   @ 360, 10 button cmdPrev caption "&Previous" ;
      action MovePrev()
   
   @ 360, 110 button cmdNext caption "&Next" ;
      action MoveNext()

   @ 360, 210 button cmdAdd caption "&Add" ;
      action AddRec()
   
   @ 360, 310 button cmdDelete caption "&Delete" ;
      action DeleteRec()
   
   @ 390, 110 button cmdSave caption "&Save" ;
      action SaveRec()
   
   @ 390, 210 button cmdCancel caption "&Cancel" ;
      action CancelRec()
   
END WINDOW
on key DELETE of form_1             action dodel()
on key INSERT of form_1             action doins()

CENTER WINDOW Form_1

ACTIVATE WINDOW Form_1

Return


FUNCTION CreateLookup()
   local i
   
   aItemSource := { }
   aItemDisp := { }
   aItemRate := { }
   aCustSource := { }
   aCustDisp := { }
   
   select item
   set order to tag itemnm
   do while ! eof()
      aadd( aItemSource, item->itemcd )
      aadd( aItemDisp, item->itemnm )
      aadd( aItemRate, item->rate )
      skip
   enddo
   
   select cust
   set order to tag custnm
   do while ! eof()
      aadd( aCustSource, cust->custcd )
      aadd( aCustDisp, cust->custnm )
      skip
   enddo
   
   return nil
   

FUNCTION RefreshWin()
   if lAddMode
      select sale
      go bottom
      form_1.txtInvno.value := str( val( sale->invno ) + 1, 10 )
      form_1.dpkInvdt.value := date()
      form_1.cboCustcd.value := 0
      form_1.txtTotamt.value := 0.00

      aGrid := { }
      form_1.grdSaledtl.DeleteAllItems()
   else
      form_1.txtInvno.value := sale->invno
      form_1.dpkInvdt.value := sale->invdt
      form_1.cboCustcd.value := ascan( aCustSource, { | x | x == sale->custcd } )
      form_1.txtTotamt.value := sale->totamt
      
      aGrid := { }
      select saledtl
      set order to tag invno
      locate for invno = sale->invno
      do while ! eof()
         aadd( aGrid, { ascan( aItemSource, { | x | x == saledtl->itemcd } ), ;
                        saledtl->rate, saledtl->qty, saledtl->rate * saledtl->qty } )
         continue
      enddo
      form_1.grdSaledtl.DeleteAllItems()
      for i = 1 to len( aGrid )
         form_1.grdSaledtl.additem( aGrid[ i ] )
      next
      form_1.browse_1.setfocus()
      
   endif
   form_1.browse_1.refresh()
   RefreshEditable()
   return nil
   

FUNCTION RefreshEditable()

   form_1.cmdPrev.enabled := ! lChanged
   form_1.cmdNext.enabled := ! lChanged
   form_1.cmdAdd.enabled := ! lChanged
   form_1.cmdDelete.enabled := ! lChanged
   form_1.cmdSave.enabled := lChanged
   form_1.cmdCancel.enabled := lChanged
   form_1.browse_1.enabled := ! lChanged
   
   return nil
   

   
PROCEDURE CalcAmt()
   local i, nIctr, aTemp := { }, mTotAmt := 0.00
   // lChange := .t.
   i := form_1.grdSaledtl.value
   nIctr :=  form_1.grdSaledtl.cell( i, 1 )
   aTemp := form_1.grdSaledtl.item( i )
   if i < 1
      return
   endif
   aTemp[ 2 ] := iif( nIctr > 0 .and. nIctr <= len( aItemRate ), aItemRate[ nIctr ], 0.00 )
   aTemp[ 4 ] := aTemp[ 2 ] * aTemp[ 3 ]
   form_1.grdSaledtl.item( i ) := aTemp

   for i = 1 to form_1.grdSaledtl.Itemcount
      mTotAmt += form_1.grdSaledtl.cell( i, 4 )
   next
   form_1.txtTotamt.value := mTotAmt
   return
   

PROCEDURE MovePrev()
   select sale
   if ! bof()
      skip - 1
   endif
   if bof()
      go top
   endif
   RefreshWin()
   return
   

PROCEDURE MoveNext()
   select sale
   if ! eof()
      skip
   endif
   if eof()
      go bottom
   endif
   RefreshWin()
   return

   
FUNCTION ValChanged()
   if ! lChanged
      lChanged := .t.
      RefreshEditable()
   endif
   return nil


FUNCTION AddRec()
   lAddMode := .t.
   lChanged := .t.
   RefreshWin()
   form_1.dpkInvdt.setfocus()
   return nil


FUNCTION DeleteRec()
   if ! MsgYesNo( "Do you really want to delete?" )
      return
   endif
   select sale
   if eof()
      msgbox( "Cannot Delete" ) ; return
   endif
   select saledtl
   delete all for invno = sale->invno
   select sale
   delete
   skip
   if eof()
      go bottom
   endif
   RefreshWin()
   return nil


FUNCTION SaveRec()
   local i
   select sale
   if eof()
      msgbox( "Please Add and then Save..." ) ;return
   endif
   if empty( form_1.dpkInvdt.value )
      msgbox( "Please specify Invoice date!" ) ; form_1.dpkInvdt.setfocus() ; return
   endif
   if empty( form_1.cboCustcd.value )
      msgbox( "Please specify Customer!" ) ; form_1.cboCustcd.setfocus() ; return
   endif
   if empty( form_1.grdSaledtl.itemcount )
      msgbox( "Invoice must have Items!" ) ; form_1.grdSaledtl.setfocus() ;return
   endif
   for i := 1 to form_1.grdSaledtl.itemcount
      do case
      case empty( form_1.grdSaledtl.cell( i, 1 ) )
         msgbox( "Please specify Item!" ) ;return
      case empty( form_1.grdSaledtl.cell( i, 2 ) )
         msgbox( "Blank Rate not allowed!" ) ;return
      case empty( form_1.grdSaledtl.cell( i, 3 ) )
         msgbox( "Blank Qty not allowed!" ) ;return
      endcase
   next
   select sale
   if lAddMode
      append blank
   endif
   sale->invno := form_1.txtInvno.value
   sale->invdt := form_1.dpkInvdt.value
   sale->custcd := aCustSource[ form_1.cboCustcd.value ]
   sale->totamt := form_1.txtTotamt.value

   select saledtl
   if ! lAddMode
      delete all for invno = sale->invno
   endif
   for i := 1 to form_1.grdSaledtl.itemcount
      append blank
      saledtl->invno := sale->invno
      saledtl->itemcd := aItemSource[ form_1.grdSaledtl.cell( i, 1 ) ]
      saledtl->rate := form_1.grdSaledtl.cell( i, 2 )
      saledtl->qty := form_1.grdSaledtl.cell( i, 3 )
   next
   lAddMode := lChanged := .f.
   RefreshWin()
   return nil

   
FUNCTION CancelRec()
   lAddMode := lChanged := .f.
   RefreshWin()
   return nil


Function SetProg()
   set talk off
   set dele on
   set date brit
   set cent on
   set epoch to 1950
   SET BROWSESYNC ON
   SET NAVIGATION EXTENDED
   SET INTERACTIVECLOSE QUERY MAIN
   set font to "Arial", 09
   REQUEST DBFCDX , DBFFPT
   RDDSETDEFAULT( "DBFCDX" )
   return nil



FUNCTION CreateTable()
   local aDbf := { }

   if ! file( "item.dbf" )
      aDbf := { }
      aadd( aDbf,   { "itemcd",   "c",   10,   0 } )
      aadd( aDbf,   { "itemnm",   "c",   20,   0 } )
      aadd( aDbf,   { "rate",     "n",    8,   2 } )
      dbcreate( "item", aDbf )
      use item
      append blank
      replace itemcd with "COMP", itemnm with "Computer", rate with 20000.00
      append blank
      replace itemcd with "CD", itemnm with "Compact Disk", rate with 10.00
      append blank
      replace itemcd with "OPM", itemnm with "Optical Mouse", rate with 400.00
      use
   endif
   
   if ! file( "cust.dbf" )
      aDbf := { }
      aadd( aDbf,   { "custcd",    "c",   10,   0 } )
      aadd( aDbf,   { "custnm",   "c",   20,   0 } )
      dbcreate( "cust", aDbf )
      use cust
      append blank
      REPLACE CUSTCD WITH "CUST1", CUSTNM WITH "Customer One"
      append blank
      REPLACE CUSTCD WITH "CUST2", CUSTNM WITH "Customer Two"
      append blank
      REPLACE CUSTCD WITH "CUST3", CUSTNM WITH "Customer Three"
      use
   endif

   if ! file( "sale.dbf" )
      aDbf := { }
      aadd( aDbf,   { "invno",   "c",   10,   0 } )
      aadd( aDbf,   { "invdt",   "d",    8,   0 } )
      aadd( aDbf,   { "custcd",  "c",   10,   0 } )
      aadd( aDbf,   { "totamt",  "n",   10,   2 } )
      dbcreate( "sale", aDbf )
      use sale
      append blank
      replace invno with str( 1, 10 ), invdt with date(), custcd with "CUST1", totamt with 40200.00
      append blank
      replace invno with str( 2, 10 ), invdt with date(), custcd with "CUST2", totamt with 420
      use
   endif
   
   if ! file( "saledtl.dbf" )
      aDbf := { }
      aadd( aDbf,   { "invno",    "c",   10,   0 } )
      aadd( aDbf,   { "itemcd",   "c",   10,   0 } )
      aadd( aDbf,   { "rate",     "n",    8,   2 } )
      aadd( aDbf,   { "qty",      "n",    6,   0 } )
      dbcreate( "saledtl", aDbf )
      use saledtl
      append blank
      replace invno with str( 1, 10 ), itemcd with "COMP", rate with 20000.00, qty with 2
      append blank
      replace invno with str( 1, 10 ), itemcd with "CD", rate with 10.00, qty with 20
      append blank
      replace invno with str( 2, 10 ), itemcd with "CD", rate with 10.00, qty with 5
      append blank
      replace invno with str( 2, 10 ), itemcd with "OPM", rate with 400.00, qty with 1
      use
   endif
   close databases
   use item new
   use cust new
   use sale new
   use saledtl new

   select item
   index on itemcd tag itemcd
   index on upper( itemnm ) tag itemnm

   select cust
   index on custcd tag custcd
   index on upper( custnm ) tag custnm

   select sale
   index on invno tag invno
   index on invdt tag invdt
   index on custcd tag custcd

   select saledtl
   index on invno tag invno
   index on itemcd tag intemcd
   
   return nil
   
   
function dodel
   local lineno := form_1.grdsaledtl.value
   if  lineno > 0
      form_1.grdsaledtl.deleteitem( lineno )
      lChanged := .t.
      if lineno > 1
         form_1.grdsaledtl.value := lineno - 1
      else
         if form_1.grdsaledtl.itemcount > 0
            form_1.grdsaledtl.value := 1
         endif
      endif
   endif
   calcamt()
   return nil
   
   
function doins
   //if form_1.grdSaledtl.cell(form_1.grdsaledtl.itemcount, 4) > 0.0
   //   form_1.grdsaledtl.additem({1,aitemrate[1],0,0.00})
   //endif
   form_1.grdsaledtl.additem( { 0, 0.00, 0, 0.00 } )
   form_1.grdSaledtl.value := form_1.grdsaledtl.itemcount
   lChanged := .t.
   return nil